package nxm.nmpostlegacy.prim;

import nxm.sys.inc.*;
import nxm.sys.lib.*;
import nxm.nmpostlegacy.lib.*;

public class testftp extends Primitive implements FtpClient_cb {
  private FtpClient ftp          = null;
  private boolean   FileComplete = false;

  public int open() {
    ftp = new FtpClient(true,         // QUIET Flag for FTP/Debug messages
        "ftp_hostname",               // FTP Target Host
        "/path/to/place/target/file/",// Path to place the target file.
        "/path/to/get/file.tmp",      // The file to get.  FULL target directory, or must be in LOGIN
        "ftp_user",                   // FTP account (user)
        "ftp_password",               // FTP account password
        this);                        // Object that implements the Callbacks.  (FtpClient_cb)
    return NORMAL;
  }

  public int process() {
    if (FileComplete) return FINISH;
    return NOOP;
  }

  public synchronized void FTPStatus(int status,FtpClient client){
    M.info("FTPStatus is "+status);
    switch(status){
      case FtpClient.XFER_COMPLETE:  FileComplete=true; break;
    }
  }

  public synchronized void FTPPercent(double percent,FtpClient client){
    M.info(client.filename+" Percent is "+percent);
  }

}
