!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Macro to initialize system specific settings.
! @author Jeff Schoen
! @version $Id: nmstartup.mm,v 1.37 2011/11/10 20:58:41 ntn Exp $
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
startmacro

info "DEPRECATION warnings ON, to turn off edit nmstartup.mm in SYS->CFG"
debug on DEPRECATE

! portable way to define normal auxes (1 = /midas/data1/+/, etc.)
file name u:aux.1  (midas,data1,+)
file name u:aux.11 (midas,data11)
file name u:aux.12 (midas,data12)
file name u:aux.99 (midas,opt,xmxxx,xm,dat)
file name u:aux.9  (ramd:,midas,icedisk)
set U:AUX.WEB "http://nextmidas.techma.com/nm/nxm/sys/dat/"
!set U:AUX.WEB "http://www.ice-online.com/ftp/"

! define OS specific AUXes
if env.ostype eqs "UNIX"
  sedit AUX.9 AUX.9 append ",RAM,AUTO"
! sedit AUX.9 AUX.9 append ",RAM,<start>M,<sized>M"
  set U:AUX.71 "ice:/midas/icefs1/,/etc/icefs1.conf,"
  set U:AUX.72 "ice:/midas/icefs2/,/etc/icefs2.conf,"
elseif env.ostype eqs "DOS"
  sedit AUX.9 AUX.9 append ",RAM,<start>M,<sized>M"
elseif env.ostype eqs "VMS"
  ! nothing specific for VMS
endif

! set write AUX and read AUX list
aux 1 1 cwd dat 99 ram

path set dsp hwc

env set "HWFILE" "nxm.sys.dat.hwconfig"
res t:km "nxm.sys.cfg.keyMap.tbl"
env set KEYMAP ^km

endmacro
