package nxm.sys.inc;

import java.awt.Graphics;

/** DEPRECATED since NeXtMidas 2.5.5: No longer required, will be deleted from future releases,
    see {@link nxm.sys.libg.ExportImage} for details.
    
    @since   NeXtMidas Version 1.7.5
    @author  J. Czechowski IV
    @version $Id: ExportsImage.java,v 1.3 2008/03/12 00:57:42 jxc Exp $
 */
public interface ExportsImage {
  /** This will paint the exported image to a specified graphics component.
    
      @param graphics The Graphics component to copy the image to.
   
      @see #getExportHeight()
      @see #getExportWidth()
   */
  public void exportTo(Graphics graphics);
  
  /** Specifies the width of the exported image.
   
      @return The width of the exported image.
   
      @see #getExportHeight()
      @see #exportTo(Graphics)
   */
  public int getExportWidth();
  
  /** Specifies the height of the exported image.
   
      @return The height of the exported image.
   
      @see #getExportWidth()
      @see #exportTo(Graphics)
   */
  public int getExportHeight();
}
