package nxm.sys.inc;

/** Interface Definition for an object with a registry ID.

    @author Jeff Schoen
    @version $Id: IDable.java,v 1.6 2007/08/21 15:06:55 ntn Exp $
 */
public interface IDable {

  /** This will get the registry ID from the object.

      @return The registry ID for the object as a String.
   */
  public String getID ();

}
