package nxm.sys.intr;

import nxm.sys.lib.*;

/**
  Exits the current shell, saving the current session.

  @author Jeff Schoen
  @version $Id: Exit.java,v 1.6 2009/08/18 13:15:23 jwb Exp $
*/
public class Exit extends Intrinsic {

  public int process() {
    if (M.terminal.archiver != null) M.terminal.archiver.close();
    // M.status = EXIT;  this is now handled by the shell class
    return FINISH;
  }
}
