package nxm.sys.intr;

import nxm.sys.inc.*;
import nxm.sys.lib.*;

/** Resumes execution of a macro in suspend mode

  @author Jeff Schoen
  @version $Id: Go.java,v 1.2 2007/04/11 20:10:31 ntn Exp $
*/
public class Go extends Intrinsic {

  public int process() {

    if (M.macro == null || M.macro.suspend==0) {
      M.error("No macro suspended ...");
      return FINISH;
    }
    int step = MA.getL("STEP");
    M.macro.nextIndex += step;
    M.macro.suspend = 0;

    return FINISH;
  }
}
