package nxm.sys.intr;

import nxm.sys.inc.*;
import nxm.sys.lib.*;

/**
  Executes a jump to the named label in the macro language.

  @author Jeff Schoen
  @version $Id: Goto.java,v 1.5 2007/04/11 20:10:31 ntn Exp $

*/
public class Goto extends Intrinsic {

  public int process() {

    if (M.macro == null) {
      M.error("No macro executing ...");
      return FINISH;
    }
    String label = MA.getU("NAME");
    int index = M.macro.lookupIndex (label);
    if (index>0) M.macro.nextIndex = index;
    else M.error ("Label name "+label+" not found");
    return FINISH;
  }
}
