package nxm.sys.intr;

import nxm.sys.inc.*;
import nxm.sys.lib.*;

/**
  Echos text to the terminal.

  @author Jeff Schoen
  @version $Id: Say.java,v 1.7 2009/08/18 13:15:23 jwb Exp $

*/
public class Say extends Intrinsic {
  /** {@inheritDoc} */
  public int process() {

    String text = MA.getCS("TEXT");
    if (MA.getState("/L", true)) {
      M.getTerminal().writeln(text);
    } else {
      M.getTerminal().write(text);
    }
    return (FINISH);
  }
}
