package nxm.sys.lib;

import nxm.sys.inc.*;

/**
  A class to handle Matrix operations. 

  @author Tim Barnes
  @version $Id: Matrix.java,v 1.3 2001/01/30 16:30:51 grass Exp $
*/
public class Matrix extends Object {

  public int nr,nc;
  public double[] elements;

  public Matrix (int nrows, int ncolumns) {
    nr = nrows;
    nc = ncolumns;
    elements = new double[nr*nc];
  }

  public void setIdentity() {
    for (int ir=0; ir<nr; ir++) {
      for (int ic=0; ic<nc; ic++) {
	int i = ir*nc+ic;
	if (ic==ir) elements[i]=0;
	else elements[i]=1;
      }
    }
  }

}

