// <BBMakeDefs>
// <Colortype size="56">
//     0, short[28]           , getTable               , setTable               , ""
// </Colortype>
// <MAIN>
//     0, FortranString(L_CMD_CHARS), getCommandString , setCommandString       , "input string"
//     ~, FortranString(L_GSW_CHARS), getGlobalSwitchString, setGlobalSwitchString, "global switch string"
//     ~, int                 , getCommandLength       , setCommandLength       , "input string length"
//     ~, int                 , getSwitchLength        , setSwitchLength        , "switch string length"
//     ~, int                 , getGlobalSwitchLength  , setGlobalSwitchLength  , "global switch string length"
//     ~, int                 , getNumberParameters    , setNumberParameters    , "number of command parameters"
//     ~, FortranString(40)   , getCommandName         , setCommandName         , "name of command"
//     ~, AsciiChar           , getCommandSupport      , setCommandSupport      , "command support type"
//     ~, byte                , getEngine              , setEngine              , "local engine #"
//     ~, byte                , getDsEngine            , setDsEngine            , "datastream engine"
//     ~, byte                , getDsDefEngine         , setDsDefEngine         , "datastream default engine"
//     ~, int                 , getVerify              , setVerify              , "verify flag"
//     ~, int                 , getDebug               , setDebug               , "debug flag"
//     ~, Boolean(int)        , getBreak               , setBreak               , "control-C break flag"
//     ~, Boolean(int)        , getSysunlock           , setSysunlock           , "raise to escape blocked calls"
//     ~, Boolean(int)        , getBeep                , setBeep                , "prim completion beep flag"
//     ~, int                 , getStatus              , setStatus              , "primitive return status"
//     ~, int                 , getCount               , setCount               , "primitive count (for pipes)"
//     ~, int                 , getMode                , setMode                , "0-norm 1,2,3"
//     ~, int                 , getDatastream          , setDatastream          , "datastream action flag"
//     ~, FortranString(4)    , getOsType              , setOsType              , "Operating system (VMS, UNIX)"
//     ~, FortranString(4)    , getOsName              , setOsName              , "Specific to vendor (OSF, SUN)"
//     ~, FortranString(4)    , getMachine             , setMachine             , "Machine data representation"
//     ~, FortranString(16)   , getHostname            , setHostname            , "Host name"
//     ~, FortranString(8)    , getPipeable            , setPipeable            , "Pipeable support list"
//     ~, FortranString(60)   , getLoginPath           , setLoginPath           , "path for HISTORY FILES"
//     ~, FortranString(256)  , getHomePath            , setHomePath            , "current HOME path"
//     ~, FortranString(40)   , getPlotNode            , setPlotNode            , "X-Windows screen designator"
//     ~, FortranString(40)   , getPlotNode2           , setPlotNode2           , "secondary screen designator"
//     ~, int                 , getLeft                , setLeft                , "default X-WIndows left"
//     ~, int                 , getTop                 , setTop                 , "default X-Windows top"
//     ~, int                 , getWidth               , setWidth               , "default X-Windows width"
//     ~, int                 , getHeight              , setHeight              , "default X-Windows height"
//     ~, int                 , getWindowId            , setWindowId            , "X-Windows window ID"
//     ~, short               , getWindowW             , setWindowW             , "X-Window actual width (pixels)"
//     ~, short               , getWindowH             , setWindowH             , "X-Window actual hght (pixels)"
//     ~, Colortype[4]        , getColormap            , setColormap            , "colormap environments"
//     ~, FortranString(L_AUXBYTES), getAuxList        , setAuxList             , "auxiliary disks list"
//     ~, FortranString(60)   , getWriteId             , setWriteId             , "current write ID string"
//     ~, FortranString(60)   , getReadId              , setReadId              , "current read ID string"
//     ~, FortranString(8)    , getUserId              , setUserId              , "User identification string"
//     ~, int                 , getWriteAux            , setWriteAux            , "current write aux number"
//     ~, int                 , getReadAuxs            , setReadAuxs            , "# currently active read auxs"
//     ~, short[L_MAXAUXINDEX+1], getAuxOffset         , setAuxOffset           , "read aux list offset table"
//     ~, byte[L_AUXS]        , getReadAux             , setReadAux             , "read aux table"
//     ~, int                 , getMasterslave         , setMasterslave         , "master/slave controller mode"
//     ~, Boolean(int)        , getDetached            , setDetached            , "detached header mode"
//     ~, int                 , getDetachAux           , setDetachAux           , "aux # for detached data"
//     ~, int                 , getDetachStart         , setDetachStart         , "detached header start offset"
//     ~, int                 , getNextFileLu          , setNextFileLu          , "next available file log unit"
//     ~, int                 , getPipesize            , setPipesize            , "default pipe size (bytes)"
//     ~, int                 , getPropmask            , setPropmask            , "header keyword propagate mask"
//     ~, int                 , getMacro               , setMacro               , "current macro pointer"
//     ~, int                 , getMacroLevel          , setMacroLevel          , "macro nest level"
//     ~, int                 , getDictionarySize      , setDictionarySize      , "data storage for dictionary"
//     ~, int                 , getDictionaryCmds      , setDictionaryCmds      , "current max commands allowed"
//     ~, int                 , getResultsSize         , setResultsSize         , "data storage for results"
//     ~, int                 , getResultsBins         , setResultsBins         , "current hash bins"
//     ~, float               , getTimer               , setTimer               , "Continuous primitive timer"
//     ~, float               , getElapse              , setElapse              , "Elapsed timer"
//     ~, float               , getPause               , setPause               , "Wait time for polling loops"
//     ~, int                 , getSeed                , setSeed                , "Random number seed"
//     ~, int                 , getScratch             , setScratch             , "scratch area"
//     ~, FortranString(4)    , getNformat             , setNformat             , "numeric format"
//     ~, int[L_SECTIONS]     , getSecSz               , setSecSz               , "shared memory section sizes"
//     ~, int[L_USERSCR]      , getUserscr             , setUserscr             , "user scratch area"
//     ~, float               , getTolerance           , setTolerance           , "equivalence tolerance"
//     ~, int                 , getSyncCount           , setSyncCount           , ""
//     ~, int                 , getPresyncCount        , setPresyncCount        , ""
//     ~, int                 , getInputLu             , setInputLu             , ""
//     ~, FortranString(4)    , getInputType           , setInputType           , ""
//     ~, int                 , getKeyLu               , setKeyLu               , ""
//     ~, FortranString(4)    , getKeyType             , setKeyType             , ""
//     ~, int                 , getCrtLu               , setCrtLu               , ""
//     ~, FortranString(4)    , getCrtType             , setCrtType             , ""
//     ~, int                 , getListLu              , setListLu              , ""
//     ~, FortranString(4)    , getListType            , setListType            , ""
//     ~, int                 , getLpLu                , setLpLu                , ""
//     ~, FortranString(4)    , getLpType              , setLpType              , ""
//     ~, int                 , getPlotterLu           , setPlotterLu           , ""
//     ~, FortranString(4)    , getPlotterType         , setPlotterType         , ""
//     ~, int                 , getGraphicsLu          , setGraphicsLu          , ""
//     ~, FortranString(4)    , getGraphicsType        , setGraphicsType        , ""
//     ~, int                 , getLineType            , setLineType            , ""
//     ~, int                 , getAbsUnits            , setAbsUnits            , ""
//     ~, float               , getXmin                , setXmin                , ""
//     ~, float               , getXmax                , setXmax                , ""
//     ~, float               , getYmin                , setYmin                , ""
//     ~, float               , getYmax                , setYmax                , ""
//     ~, float               , getXMult               , setXMult               , ""
//     ~, int                 , getRsact               , setRsact               , "remote session action flag"
//     ~, int                 , getVisclass            , setVisclass            , "default /VISCLASS"
//     ~, int                 , getVisdepth            , setVisdepth            , "default /VISDEPTH"
//     ~, int                 , getVisid               , setVisid               , "default /VISUALID"
//     ~, int                 , getRemote              , setRemote              , ""
//     ~, int                 , getFill                , setFill                , ""
//     ~, int                 , getUseExecutables      , setUseExecutables      , ""
//     ~, float               , getSockPause           , setSockPause           , "Added for DR 10626"
// </MAIN>
// </BBMakeDefs>
package nxm.sys.libxm;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

import nxm.sys.lib.Shell;


/** A class that wraps the native MCOMMON structure for Mc; this is an automatically generated class. DO NOT EDIT!!! */
class Mc {
  /** Loads the JNI library. */
  static {
    Shell.loadLibrary(Mc.class.getName());
  }
  
  /** The byte buffer to use. */
  private static ByteBuffer byteBuffer;
  
  /** Creates a new instance. */
  private Mc() { }
  
  /** Gets the byte buffer.
      @return The byte buffer.
   */
  public static ByteBuffer getByteBuffer() {
    if (byteBuffer == null) {
      byteBuffer = getByteBuffer0();
      byteBuffer.order(ByteOrder.nativeOrder());
    }
    return byteBuffer;
  }
  
  /** Gets the byte buffer. This should only be called by getByteBuffer().<br>
      <br>
      WARNING: The byte buffer returned by this method will need to have its
               byte order set using byteBuffer.order(ByteOrder.nativeOrder())
               before it can be accessed.
               
      @return The byte buffer.
   */
  private static native ByteBuffer getByteBuffer0();
  
  /** max # of 'ordinary' macro levels */
  public static final int L_MLEVELS = 32;
  
  /** max spawned macro level */
  public static final int L_MACROS = 96;
  
  /** max size of read auxilary list */
  public static final int L_AUXS = 64;
  
  /** max total characters of all auxs */
  public static final int L_AUXBYTES = 4096;
  
  /** max index into auxiliary table */
  public static final int L_MAXAUXINDEX = 255;
  
  /** max chars in command line */
  public static final int L_CMD_CHARS = 1024;
  
  /** max global switch chars */
  public static final int L_GSW_CHARS = 1024;
  
  /** max files/prim for overwrite autochk */
  public static final int L_FILES = 10;
  
  /** max results array files open at once */
  public static final int L_SHELLFILES = 10;
  
  /** max user scratch fields */
  public static final int L_USERSCR = 32;
  
  /** max length of pipe name */
  public static final int L_PIPE_NAME = 32;
  
  /** max scalars per atom */
  public static final int L_MAXSPA_ = 16;
  
  /** max number of global sections */
  public static final int L_SECTIONS = 64;
  
  /** shared section mask - bits 3,4,5 */
  public static final int L_SHRMASK = 56;
  
  /** unknown */
  public static final int LS_MIDAS = 1;
  
  /** unknown */
  public static final int LS_TABLES = 2;
  
  /** unknown */
  public static final int LS_RESULTS = 3;
  
  /** unknown */
  public static final int LS_MESSAGES = 4;
  
  /** unknown */
  public static final int LS_DICTIONARY = 5;
  
  /** unknown */
  public static final int LS_MACROSTACK = 6;
  
  /** unknown */
  public static final int LS_PIPE_HEADERS = 7;
  
  /** unknown */
  public static final int LS_PIPE_BUFFERS = 8;
  
  /** unknown */
  public static final int LS_CNTRL_WIDGETS = 9;
  
  /** unknown */
  public static final int LS_DS_STRUCTS = 10;
  
  /** unknown */
  public static final int LS_USER_OFFSET = 10;
  
  /** unknown */
  public static final int LS_USER1 = 11;
  
  /** unknown */
  public static final int LS_USER2 = 12;
  
  /** unknown */
  public static final int LS_USER3 = 13;
  
  /** unknown */
  public static final int LS_PNAME = 14;
  
  /** unknown */
  public static final int LS_REMOTE = 15;
  
  /** ipc message buffer */
  public static final int LS_ERMIF_IPC = 16;
  
  /** pipe tranesfer buffers */
  public static final int LS_REMOTE_PIPES_OFFSET = 17;
  
  /** unknown */
  public static final int L_SEMAPHORES = 9;
  
  /** key for M$LOCK */
  public static final int LS_ALL_SECTIONS = -1;
  
  /** max user sections */
  public static final int L_USERSEC = L_SECTIONS-LS_USER_OFFSET;
  
  /** unknown */
  public static final int LD_WAIT = 1;
  
  /** unknown */
  public static final int LD_SUBSHELL = 2;
  
  /** unknown */
  public static final int LD_SMART = 4;
  
  /** unknown */
  public static final int LD_SYMBOLS = 8;
  
  /** unknown */
  public static final int LD_NOINPUT = 16;
  
  /** unknown */
  public static final Mc MC = new Mc();
  
  /** unknown */
  public static final int L_MIDAS_COMMON = 8220;
  
  /** unknown */
  public static final int L_MAX_PKT_FILES = 36;
  
  /** unknown */
  public static final int L_MU_PKT_ADJUNCT_SIZE = L_MAX_PKT_FILES*328+4;
  
  /** unknown */
  protected int M_PPID;
  
  /** unknown */
  protected int M_SPID;
  
  /** unknown */
  protected int M_SHRMASK;
  
  /** unknown */
  public static final int L_MIDAS_UNIQUE = 480+L_MU_PKT_ADJUNCT_SIZE;
  
  /** Each record in 88 bytes */
  public static final int PNAME_RECORD_SIZE = 88;
  
  /** Number of records in array */
  public static final int PNAME_ARRAY_SIZE = 512;
  
  /** unknown */
  public static final int L_PNAME = PNAME_RECORD_SIZE*PNAME_ARRAY_SIZE;
  
  /** unknown */
  public static final int P_NULL = 0;
  
  /** unknown */
  public static final int P_PIPE = 1;
  
  /** unknown */
  public static final int P_RESULT = 2;
  
  /** unknown */
  public static final int P_KEY = 3;
  
  /** unknown */
  public static final int P_MESSAGE = 4;
  
  /** unknown */
  public static final int P_MACRO = 5;
  
  /** unknown */
  public static final int P_XCONTROL = 6;
  
  /** unknown */
  public static final int P_XCALL = 7;
  
  /** unknown */
  public static final int REMOTE_RECORD_SIZE = 768;
  
  /** Number of records in array */
  public static final int REMOTE_ARRAY_SIZE = 256;
  
  /** unknown */
  public static final int L_REMOTE = REMOTE_RECORD_SIZE*REMOTE_ARRAY_SIZE;
  
  /** unknown */
  public static final int IPC_SLOTS_MAIN_MACRO = 1024;
  
  /** unknown */
  public static final int IPC_SLOTS_PER_MACRO = 128;
  
  /** unknown */
  public static final int IPC_MAX_MACROS = 16;
  
  /** unknown */
  public static final int IPC_MAX_MACROS_SLOTS = IPC_MAX_MACROS*IPC_SLOTS_PER_MACRO;
  
  /** unknown */
  public static final int ERMIF_TABLE_SIZE = IPC_SLOTS_MAIN_MACRO+IPC_MAX_MACROS_SLOTS;
  
  /** unknown */
  public static final int ERMIF_STR_LEN = 224;
  
  /** unknown */
  public static final int ERMIF_SIZE = 256;
  
  /** unknown */
  public static final int L_ERMIF_IPC = ERMIF_TABLE_SIZE*4+ERMIF_TABLE_SIZE*ERMIF_SIZE;
  
  // <BBMakeGenCode>//GEN-BEGIN:BBMakeGenCode
  /* This next section of code generated by BBDEF2JAVA in CONVERT.
     DO NOT EDIT THIS CODE, it will be re-written every time
     BBDEF2JAVA is run and any changes will be lost.
   */
  //   <editor-fold defaultstate="collapsed" desc=" Generated Code ">
  /** Gets the input string.
      @return The input string.
   */
  public static String getCommandString() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < L_CMD_CHARS; i++) {
      char letter = (char)getByteBuffer().get((0)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the input string.
      @param val The input string.
   */
  public static void setCommandString(String val) {
    for (int i = 0; i < L_CMD_CHARS; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put((0)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put((0)+i, (byte)' ');
      }
    }
  }

  /** Gets the global switch string.
      @return The global switch string.
   */
  public static String getGlobalSwitchString() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < L_GSW_CHARS; i++) {
      char letter = (char)getByteBuffer().get((L_CMD_CHARS)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the global switch string.
      @param val The global switch string.
   */
  public static void setGlobalSwitchString(String val) {
    for (int i = 0; i < L_GSW_CHARS; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put((L_CMD_CHARS)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put((L_CMD_CHARS)+i, (byte)' ');
      }
    }
  }

  /** Gets the input string length.
      @return The input string length.
   */
  public static int getCommandLength() {
    return getByteBuffer().getInt(L_CMD_CHARS+L_GSW_CHARS);
  }

  /** Sets the input string length.
      @param val The input string length.
   */
  public static void setCommandLength(int val) {
    getByteBuffer().putInt(L_CMD_CHARS+L_GSW_CHARS, val);
  }

  /** Gets the switch string length.
      @return The switch string length.
   */
  public static int getSwitchLength() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+4);
  }

  /** Sets the switch string length.
      @param val The switch string length.
   */
  public static void setSwitchLength(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+4, val);
  }

  /** Gets the global switch string length.
      @return The global switch string length.
   */
  public static int getGlobalSwitchLength() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+8);
  }

  /** Sets the global switch string length.
      @param val The global switch string length.
   */
  public static void setGlobalSwitchLength(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+8, val);
  }

  /** Gets the number of command parameters.
      @return The number of command parameters.
   */
  public static int getNumberParameters() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+12);
  }

  /** Sets the number of command parameters.
      @param val The number of command parameters.
   */
  public static void setNumberParameters(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+12, val);
  }

  /** Gets the name of command.
      @return The name of command.
   */
  public static String getCommandName() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 40; i++) {
      char letter = (char)getByteBuffer().get(((L_CMD_CHARS+L_GSW_CHARS)+16)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the name of command.
      @param val The name of command.
   */
  public static void setCommandName(String val) {
    for (int i = 0; i < 40; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+16)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+16)+i, (byte)' ');
      }
    }
  }

  /** Gets the command support type.
      @return The command support type.
   */
  public static char getCommandSupport() {
    return (char)getByteBuffer().get((L_CMD_CHARS+L_GSW_CHARS)+56);
  }

  /** Sets the command support type.
      @param val The command support type.
   */
  public static void setCommandSupport(char val) {
    if (val > 0x7f) {
      throw new IllegalArgumentException("Expected ASCII character given '"+val+"'.");
    }
    getByteBuffer().put((L_CMD_CHARS+L_GSW_CHARS)+56, (byte)val);
  }

  /** Gets the local engine #.
      @return The local engine #.
   */
  public static byte getEngine() {
    return getByteBuffer().get((L_CMD_CHARS+L_GSW_CHARS)+57);
  }

  /** Sets the local engine #.
      @param val The local engine #.
   */
  public static void setEngine(byte val) {
    getByteBuffer().put((L_CMD_CHARS+L_GSW_CHARS)+57, val);
  }

  /** Gets the datastream engine.
      @return The datastream engine.
   */
  public static byte getDsEngine() {
    return getByteBuffer().get((L_CMD_CHARS+L_GSW_CHARS)+58);
  }

  /** Sets the datastream engine.
      @param val The datastream engine.
   */
  public static void setDsEngine(byte val) {
    getByteBuffer().put((L_CMD_CHARS+L_GSW_CHARS)+58, val);
  }

  /** Gets the datastream default engine.
      @return The datastream default engine.
   */
  public static byte getDsDefEngine() {
    return getByteBuffer().get((L_CMD_CHARS+L_GSW_CHARS)+59);
  }

  /** Sets the datastream default engine.
      @param val The datastream default engine.
   */
  public static void setDsDefEngine(byte val) {
    getByteBuffer().put((L_CMD_CHARS+L_GSW_CHARS)+59, val);
  }

  /** Gets the verify flag.
      @return The verify flag.
   */
  public static int getVerify() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+60);
  }

  /** Sets the verify flag.
      @param val The verify flag.
   */
  public static void setVerify(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+60, val);
  }

  /** Gets the debug flag.
      @return The debug flag.
   */
  public static int getDebug() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+64);
  }

  /** Sets the debug flag.
      @param val The debug flag.
   */
  public static void setDebug(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+64, val);
  }

  /** Gets the control-C break flag.
      @return The control-C break flag.
   */
  public static boolean getBreak() {
    return (getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+68) != 0);
  }

  /** Sets the control-C break flag.
      @param val The control-C break flag.
   */
  public static void setBreak(boolean val) {
    int num = (val)? 1: 0;
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+68, (int)num);
  }

  /** Gets the raise to escape blocked calls.
      @return The raise to escape blocked calls.
   */
  public static boolean getSysunlock() {
    return (getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+72) != 0);
  }

  /** Sets the raise to escape blocked calls.
      @param val The raise to escape blocked calls.
   */
  public static void setSysunlock(boolean val) {
    int num = (val)? 1: 0;
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+72, (int)num);
  }

  /** Gets the prim completion beep flag.
      @return The prim completion beep flag.
   */
  public static boolean getBeep() {
    return (getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+76) != 0);
  }

  /** Sets the prim completion beep flag.
      @param val The prim completion beep flag.
   */
  public static void setBeep(boolean val) {
    int num = (val)? 1: 0;
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+76, (int)num);
  }

  /** Gets the primitive return status.
      @return The primitive return status.
   */
  public static int getStatus() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+80);
  }

  /** Sets the primitive return status.
      @param val The primitive return status.
   */
  public static void setStatus(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+80, val);
  }

  /** Gets the primitive count (for pipes).
      @return The primitive count (for pipes).
   */
  public static int getCount() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+84);
  }

  /** Sets the primitive count (for pipes).
      @param val The primitive count (for pipes).
   */
  public static void setCount(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+84, val);
  }

  /** Gets the 0-norm 1,2,3.
      @return The 0-norm 1,2,3.
   */
  public static int getMode() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+88);
  }

  /** Sets the 0-norm 1,2,3.
      @param val The 0-norm 1,2,3.
   */
  public static void setMode(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+88, val);
  }

  /** Gets the datastream action flag.
      @return The datastream action flag.
   */
  public static int getDatastream() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+92);
  }

  /** Sets the datastream action flag.
      @param val The datastream action flag.
   */
  public static void setDatastream(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+92, val);
  }

  /** Gets the Operating system (VMS, UNIX).
      @return The Operating system (VMS, UNIX).
   */
  public static String getOsType() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 4; i++) {
      char letter = (char)getByteBuffer().get(((L_CMD_CHARS+L_GSW_CHARS)+96)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the Operating system (VMS, UNIX).
      @param val The Operating system (VMS, UNIX).
   */
  public static void setOsType(String val) {
    for (int i = 0; i < 4; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+96)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+96)+i, (byte)' ');
      }
    }
  }

  /** Gets the Specific to vendor (OSF, SUN).
      @return The Specific to vendor (OSF, SUN).
   */
  public static String getOsName() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 4; i++) {
      char letter = (char)getByteBuffer().get(((L_CMD_CHARS+L_GSW_CHARS)+100)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the Specific to vendor (OSF, SUN).
      @param val The Specific to vendor (OSF, SUN).
   */
  public static void setOsName(String val) {
    for (int i = 0; i < 4; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+100)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+100)+i, (byte)' ');
      }
    }
  }

  /** Gets the Machine data representation.
      @return The Machine data representation.
   */
  public static String getMachine() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 4; i++) {
      char letter = (char)getByteBuffer().get(((L_CMD_CHARS+L_GSW_CHARS)+104)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the Machine data representation.
      @param val The Machine data representation.
   */
  public static void setMachine(String val) {
    for (int i = 0; i < 4; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+104)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+104)+i, (byte)' ');
      }
    }
  }

  /** Gets the Host name.
      @return The Host name.
   */
  public static String getHostname() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 16; i++) {
      char letter = (char)getByteBuffer().get(((L_CMD_CHARS+L_GSW_CHARS)+108)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the Host name.
      @param val The Host name.
   */
  public static void setHostname(String val) {
    for (int i = 0; i < 16; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+108)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+108)+i, (byte)' ');
      }
    }
  }

  /** Gets the Pipeable support list.
      @return The Pipeable support list.
   */
  public static String getPipeable() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 8; i++) {
      char letter = (char)getByteBuffer().get(((L_CMD_CHARS+L_GSW_CHARS)+124)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the Pipeable support list.
      @param val The Pipeable support list.
   */
  public static void setPipeable(String val) {
    for (int i = 0; i < 8; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+124)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+124)+i, (byte)' ');
      }
    }
  }

  /** Gets the path for HISTORY FILES.
      @return The path for HISTORY FILES.
   */
  public static String getLoginPath() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 60; i++) {
      char letter = (char)getByteBuffer().get(((L_CMD_CHARS+L_GSW_CHARS)+132)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the path for HISTORY FILES.
      @param val The path for HISTORY FILES.
   */
  public static void setLoginPath(String val) {
    for (int i = 0; i < 60; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+132)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+132)+i, (byte)' ');
      }
    }
  }

  /** Gets the current HOME path.
      @return The current HOME path.
   */
  public static String getHomePath() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 256; i++) {
      char letter = (char)getByteBuffer().get(((L_CMD_CHARS+L_GSW_CHARS)+192)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the current HOME path.
      @param val The current HOME path.
   */
  public static void setHomePath(String val) {
    for (int i = 0; i < 256; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+192)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+192)+i, (byte)' ');
      }
    }
  }

  /** Gets the X-Windows screen designator.
      @return The X-Windows screen designator.
   */
  public static String getPlotNode() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 40; i++) {
      char letter = (char)getByteBuffer().get(((L_CMD_CHARS+L_GSW_CHARS)+448)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the X-Windows screen designator.
      @param val The X-Windows screen designator.
   */
  public static void setPlotNode(String val) {
    for (int i = 0; i < 40; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+448)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+448)+i, (byte)' ');
      }
    }
  }

  /** Gets the secondary screen designator.
      @return The secondary screen designator.
   */
  public static String getPlotNode2() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 40; i++) {
      char letter = (char)getByteBuffer().get(((L_CMD_CHARS+L_GSW_CHARS)+488)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the secondary screen designator.
      @param val The secondary screen designator.
   */
  public static void setPlotNode2(String val) {
    for (int i = 0; i < 40; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+488)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+488)+i, (byte)' ');
      }
    }
  }

  /** Gets the default X-WIndows left.
      @return The default X-WIndows left.
   */
  public static int getLeft() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+528);
  }

  /** Sets the default X-WIndows left.
      @param val The default X-WIndows left.
   */
  public static void setLeft(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+528, val);
  }

  /** Gets the default X-Windows top.
      @return The default X-Windows top.
   */
  public static int getTop() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+532);
  }

  /** Sets the default X-Windows top.
      @param val The default X-Windows top.
   */
  public static void setTop(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+532, val);
  }

  /** Gets the default X-Windows width.
      @return The default X-Windows width.
   */
  public static int getWidth() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+536);
  }

  /** Sets the default X-Windows width.
      @param val The default X-Windows width.
   */
  public static void setWidth(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+536, val);
  }

  /** Gets the default X-Windows height.
      @return The default X-Windows height.
   */
  public static int getHeight() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+540);
  }

  /** Sets the default X-Windows height.
      @param val The default X-Windows height.
   */
  public static void setHeight(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+540, val);
  }

  /** Gets the X-Windows window ID.
      @return The X-Windows window ID.
   */
  public static int getWindowId() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+544);
  }

  /** Sets the X-Windows window ID.
      @param val The X-Windows window ID.
   */
  public static void setWindowId(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+544, val);
  }

  /** Gets the X-Window actual width (pixels).
      @return The X-Window actual width (pixels).
   */
  public static short getWindowW() {
    return getByteBuffer().getShort((L_CMD_CHARS+L_GSW_CHARS)+548);
  }

  /** Sets the X-Window actual width (pixels).
      @param val The X-Window actual width (pixels).
   */
  public static void setWindowW(short val) {
    getByteBuffer().putShort((L_CMD_CHARS+L_GSW_CHARS)+548, val);
  }

  /** Gets the X-Window actual hght (pixels).
      @return The X-Window actual hght (pixels).
   */
  public static short getWindowH() {
    return getByteBuffer().getShort((L_CMD_CHARS+L_GSW_CHARS)+550);
  }

  /** Sets the X-Window actual hght (pixels).
      @param val The X-Window actual hght (pixels).
   */
  public static void setWindowH(short val) {
    getByteBuffer().putShort((L_CMD_CHARS+L_GSW_CHARS)+550, val);
  }

  /** Gets the colormap environments.
      @return The colormap environments.
   */
  public static Colortype[] getColormap() {
    Colortype[] val = new Colortype[4];
    for (int i = 0; i < val.length; i++) {
      int offset = i * 56;
      val[i] = new Colortype(getByteBuffer(), ((L_CMD_CHARS+L_GSW_CHARS)+552)+offset);
    }
    return val;
  }

  /** Gets the auxiliary disks list.
      @return The auxiliary disks list.
   */
  public static String getAuxList() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < L_AUXBYTES; i++) {
      char letter = (char)getByteBuffer().get(((L_CMD_CHARS+L_GSW_CHARS)+776)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the auxiliary disks list.
      @param val The auxiliary disks list.
   */
  public static void setAuxList(String val) {
    for (int i = 0; i < L_AUXBYTES; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+776)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+776)+i, (byte)' ');
      }
    }
  }

  /** Gets the current write ID string.
      @return The current write ID string.
   */
  public static String getWriteId() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 60; i++) {
      char letter = (char)getByteBuffer().get(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+776)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the current write ID string.
      @param val The current write ID string.
   */
  public static void setWriteId(String val) {
    for (int i = 0; i < 60; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+776)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+776)+i, (byte)' ');
      }
    }
  }

  /** Gets the current read ID string.
      @return The current read ID string.
   */
  public static String getReadId() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 60; i++) {
      char letter = (char)getByteBuffer().get(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+836)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the current read ID string.
      @param val The current read ID string.
   */
  public static void setReadId(String val) {
    for (int i = 0; i < 60; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+836)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+836)+i, (byte)' ');
      }
    }
  }

  /** Gets the User identification string.
      @return The User identification string.
   */
  public static String getUserId() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 8; i++) {
      char letter = (char)getByteBuffer().get(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+896)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the User identification string.
      @param val The User identification string.
   */
  public static void setUserId(String val) {
    for (int i = 0; i < 8; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+896)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+896)+i, (byte)' ');
      }
    }
  }

  /** Gets the current write aux number.
      @return The current write aux number.
   */
  public static int getWriteAux() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+904);
  }

  /** Sets the current write aux number.
      @param val The current write aux number.
   */
  public static void setWriteAux(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+904, val);
  }

  /** Gets the # currently active read auxs.
      @return The # currently active read auxs.
   */
  public static int getReadAuxs() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+908);
  }

  /** Sets the # currently active read auxs.
      @param val The # currently active read auxs.
   */
  public static void setReadAuxs(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+908, val);
  }

  /** gets the read aux list offset table.
      @return The read aux list offset table (an array of size L_MAXAUXINDEX+1).
   */
  public static short[] getAuxOffset() {
    short[] val = new short[L_MAXAUXINDEX+1];
    for (int i = 0; i < val.length; i++) {
      int off = i * 2;
      val[i] = getByteBuffer().getShort(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+912)+off);
    }
    return val;
  }
  /** Gets the read aux list offset table at the specified index.
      @return The read aux list offset table at the specified index.
   */
  public static short getAuxOffsetAt(int index) {
    int off = index * 2;
    short val = getByteBuffer().getShort(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+912)+off);
    return val;
  }
  /** Sets the read aux list offset table.
      @param val The read aux list offset table (must be an array of size L_MAXAUXINDEX+1).
   */
  public static void setAuxOffset(short[] val) {
    if (val.length != L_MAXAUXINDEX+1) {
      throw new IllegalArgumentException("setAuxOffset: expected array of"
        + "length L_MAXAUXINDEX+1, given array of length "+val.length+".");
    }
    for (int i = 0; i < val.length; i++) {
      int off = i * 2;
      getByteBuffer().putShort(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+912)+off, val[i]);
    }
  }
  /** Sets the read aux list offset table at the specified index.
      @param val The read aux list offset table at the specified index.
   */
  public static void setAuxOffsetAt(int index, short val) {
    if (index >= L_MAXAUXINDEX+1) {
      throw new IllegalArgumentException("setAuxOffset: index ["+index+"] is out of range ["+L_MAXAUXINDEX+1+"]");
    }
    int off = index * 2;
    getByteBuffer().putShort(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+912)+off, val);
  }

  /** gets the read aux table.
      @return The read aux table (an array of size L_AUXS).
   */
  public static byte[] getReadAux() {
    byte[] val = new byte[L_AUXS];
    for (int i = 0; i < val.length; i++) {
      int off = i * 1;
      val[i] = getByteBuffer().get(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+912)+off);
    }
    return val;
  }
  /** Gets the read aux table at the specified index.
      @return The read aux table at the specified index.
   */
  public static byte getReadAuxAt(int index) {
    int off = index * 1;
    byte val = getByteBuffer().get(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+912)+off);
    return val;
  }
  /** Sets the read aux table.
      @param val The read aux table (must be an array of size L_AUXS).
   */
  public static void setReadAux(byte[] val) {
    if (val.length != L_AUXS) {
      throw new IllegalArgumentException("setReadAux: expected array of"
        + "length L_AUXS, given array of length "+val.length+".");
    }
    for (int i = 0; i < val.length; i++) {
      int off = i * 1;
      getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+912)+off, val[i]);
    }
  }
  /** Sets the read aux table at the specified index.
      @param val The read aux table at the specified index.
   */
  public static void setReadAuxAt(int index, byte val) {
    if (index >= L_AUXS) {
      throw new IllegalArgumentException("setReadAux: index ["+index+"] is out of range ["+L_AUXS+"]");
    }
    int off = index * 1;
    getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+912)+off, val);
  }

  /** Gets the master/slave controller mode.
      @return The master/slave controller mode.
   */
  public static int getMasterslave() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+912);
  }

  /** Sets the master/slave controller mode.
      @param val The master/slave controller mode.
   */
  public static void setMasterslave(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+912, val);
  }

  /** Gets the detached header mode.
      @return The detached header mode.
   */
  public static boolean getDetached() {
    return (getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+916) != 0);
  }

  /** Sets the detached header mode.
      @param val The detached header mode.
   */
  public static void setDetached(boolean val) {
    int num = (val)? 1: 0;
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+916, (int)num);
  }

  /** Gets the aux # for detached data.
      @return The aux # for detached data.
   */
  public static int getDetachAux() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+920);
  }

  /** Sets the aux # for detached data.
      @param val The aux # for detached data.
   */
  public static void setDetachAux(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+920, val);
  }

  /** Gets the detached header start offset.
      @return The detached header start offset.
   */
  public static int getDetachStart() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+924);
  }

  /** Sets the detached header start offset.
      @param val The detached header start offset.
   */
  public static void setDetachStart(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+924, val);
  }

  /** Gets the next available file log unit.
      @return The next available file log unit.
   */
  public static int getNextFileLu() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+928);
  }

  /** Sets the next available file log unit.
      @param val The next available file log unit.
   */
  public static void setNextFileLu(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+928, val);
  }

  /** Gets the default pipe size (bytes).
      @return The default pipe size (bytes).
   */
  public static int getPipesize() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+932);
  }

  /** Sets the default pipe size (bytes).
      @param val The default pipe size (bytes).
   */
  public static void setPipesize(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+932, val);
  }

  /** Gets the header keyword propagate mask.
      @return The header keyword propagate mask.
   */
  public static int getPropmask() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+936);
  }

  /** Sets the header keyword propagate mask.
      @param val The header keyword propagate mask.
   */
  public static void setPropmask(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+936, val);
  }

  /** Gets the current macro pointer.
      @return The current macro pointer.
   */
  public static int getMacro() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+940);
  }

  /** Sets the current macro pointer.
      @param val The current macro pointer.
   */
  public static void setMacro(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+940, val);
  }

  /** Gets the macro nest level.
      @return The macro nest level.
   */
  public static int getMacroLevel() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+944);
  }

  /** Sets the macro nest level.
      @param val The macro nest level.
   */
  public static void setMacroLevel(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+944, val);
  }

  /** Gets the data storage for dictionary.
      @return The data storage for dictionary.
   */
  public static int getDictionarySize() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+948);
  }

  /** Sets the data storage for dictionary.
      @param val The data storage for dictionary.
   */
  public static void setDictionarySize(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+948, val);
  }

  /** Gets the current max commands allowed.
      @return The current max commands allowed.
   */
  public static int getDictionaryCmds() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+952);
  }

  /** Sets the current max commands allowed.
      @param val The current max commands allowed.
   */
  public static void setDictionaryCmds(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+952, val);
  }

  /** Gets the data storage for results.
      @return The data storage for results.
   */
  public static int getResultsSize() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+956);
  }

  /** Sets the data storage for results.
      @param val The data storage for results.
   */
  public static void setResultsSize(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+956, val);
  }

  /** Gets the current hash bins.
      @return The current hash bins.
   */
  public static int getResultsBins() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+960);
  }

  /** Sets the current hash bins.
      @param val The current hash bins.
   */
  public static void setResultsBins(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+960, val);
  }

  /** Gets the Continuous primitive timer.
      @return The Continuous primitive timer.
   */
  public static float getTimer() {
    return getByteBuffer().getFloat((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+964);
  }

  /** Sets the Continuous primitive timer.
      @param val The Continuous primitive timer.
   */
  public static void setTimer(float val) {
    getByteBuffer().putFloat((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+964, val);
  }

  /** Gets the Elapsed timer.
      @return The Elapsed timer.
   */
  public static float getElapse() {
    return getByteBuffer().getFloat((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+968);
  }

  /** Sets the Elapsed timer.
      @param val The Elapsed timer.
   */
  public static void setElapse(float val) {
    getByteBuffer().putFloat((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+968, val);
  }

  /** Gets the Wait time for polling loops.
      @return The Wait time for polling loops.
   */
  public static float getPause() {
    return getByteBuffer().getFloat((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+972);
  }

  /** Sets the Wait time for polling loops.
      @param val The Wait time for polling loops.
   */
  public static void setPause(float val) {
    getByteBuffer().putFloat((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+972, val);
  }

  /** Gets the Random number seed.
      @return The Random number seed.
   */
  public static int getSeed() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+976);
  }

  /** Sets the Random number seed.
      @param val The Random number seed.
   */
  public static void setSeed(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+976, val);
  }

  /** Gets the scratch area.
      @return The scratch area.
   */
  public static int getScratch() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+980);
  }

  /** Sets the scratch area.
      @param val The scratch area.
   */
  public static void setScratch(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+980, val);
  }

  /** Gets the numeric format.
      @return The numeric format.
   */
  public static String getNformat() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 4; i++) {
      char letter = (char)getByteBuffer().get(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+984)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the numeric format.
      @param val The numeric format.
   */
  public static void setNformat(String val) {
    for (int i = 0; i < 4; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+984)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+984)+i, (byte)' ');
      }
    }
  }

  /** gets the shared memory section sizes.
      @return The shared memory section sizes (an array of size L_SECTIONS).
   */
  public static int[] getSecSz() {
    int[] val = new int[L_SECTIONS];
    for (int i = 0; i < val.length; i++) {
      int off = i * 4;
      val[i] = getByteBuffer().getInt(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+988)+off);
    }
    return val;
  }
  /** Gets the shared memory section sizes at the specified index.
      @return The shared memory section sizes at the specified index.
   */
  public static int getSecSzAt(int index) {
    int off = index * 4;
    int val = getByteBuffer().getInt(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+988)+off);
    return val;
  }
  /** Sets the shared memory section sizes.
      @param val The shared memory section sizes (must be an array of size L_SECTIONS).
   */
  public static void setSecSz(int[] val) {
    if (val.length != L_SECTIONS) {
      throw new IllegalArgumentException("setSecSz: expected array of"
        + "length L_SECTIONS, given array of length "+val.length+".");
    }
    for (int i = 0; i < val.length; i++) {
      int off = i * 4;
      getByteBuffer().putInt(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+988)+off, val[i]);
    }
  }
  /** Sets the shared memory section sizes at the specified index.
      @param val The shared memory section sizes at the specified index.
   */
  public static void setSecSzAt(int index, int val) {
    if (index >= L_SECTIONS) {
      throw new IllegalArgumentException("setSecSz: index ["+index+"] is out of range ["+L_SECTIONS+"]");
    }
    int off = index * 4;
    getByteBuffer().putInt(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+988)+off, val);
  }

  /** gets the user scratch area.
      @return The user scratch area (an array of size L_USERSCR).
   */
  public static int[] getUserscr() {
    int[] val = new int[L_USERSCR];
    for (int i = 0; i < val.length; i++) {
      int off = i * 4;
      val[i] = getByteBuffer().getInt(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+988)+off);
    }
    return val;
  }
  /** Gets the user scratch area at the specified index.
      @return The user scratch area at the specified index.
   */
  public static int getUserscrAt(int index) {
    int off = index * 4;
    int val = getByteBuffer().getInt(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+988)+off);
    return val;
  }
  /** Sets the user scratch area.
      @param val The user scratch area (must be an array of size L_USERSCR).
   */
  public static void setUserscr(int[] val) {
    if (val.length != L_USERSCR) {
      throw new IllegalArgumentException("setUserscr: expected array of"
        + "length L_USERSCR, given array of length "+val.length+".");
    }
    for (int i = 0; i < val.length; i++) {
      int off = i * 4;
      getByteBuffer().putInt(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+988)+off, val[i]);
    }
  }
  /** Sets the user scratch area at the specified index.
      @param val The user scratch area at the specified index.
   */
  public static void setUserscrAt(int index, int val) {
    if (index >= L_USERSCR) {
      throw new IllegalArgumentException("setUserscr: index ["+index+"] is out of range ["+L_USERSCR+"]");
    }
    int off = index * 4;
    getByteBuffer().putInt(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+988)+off, val);
  }

  /** Gets the equivalence tolerance.
      @return The equivalence tolerance.
   */
  public static float getTolerance() {
    return getByteBuffer().getFloat((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+988);
  }

  /** Sets the equivalence tolerance.
      @param val The equivalence tolerance.
   */
  public static void setTolerance(float val) {
    getByteBuffer().putFloat((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+988, val);
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public static int getSyncCount() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+992);
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public static void setSyncCount(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+992, val);
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public static int getPresyncCount() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+996);
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public static void setPresyncCount(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+996, val);
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public static int getInputLu() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1000);
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public static void setInputLu(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1000, val);
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public static String getInputType() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 4; i++) {
      char letter = (char)getByteBuffer().get(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1004)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public static void setInputType(String val) {
    for (int i = 0; i < 4; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1004)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1004)+i, (byte)' ');
      }
    }
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public static int getKeyLu() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1008);
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public static void setKeyLu(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1008, val);
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public static String getKeyType() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 4; i++) {
      char letter = (char)getByteBuffer().get(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1012)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public static void setKeyType(String val) {
    for (int i = 0; i < 4; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1012)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1012)+i, (byte)' ');
      }
    }
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public static int getCrtLu() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1016);
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public static void setCrtLu(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1016, val);
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public static String getCrtType() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 4; i++) {
      char letter = (char)getByteBuffer().get(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1020)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public static void setCrtType(String val) {
    for (int i = 0; i < 4; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1020)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1020)+i, (byte)' ');
      }
    }
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public static int getListLu() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1024);
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public static void setListLu(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1024, val);
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public static String getListType() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 4; i++) {
      char letter = (char)getByteBuffer().get(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1028)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public static void setListType(String val) {
    for (int i = 0; i < 4; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1028)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1028)+i, (byte)' ');
      }
    }
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public static int getLpLu() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1032);
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public static void setLpLu(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1032, val);
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public static String getLpType() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 4; i++) {
      char letter = (char)getByteBuffer().get(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1036)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public static void setLpType(String val) {
    for (int i = 0; i < 4; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1036)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1036)+i, (byte)' ');
      }
    }
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public static int getPlotterLu() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1040);
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public static void setPlotterLu(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1040, val);
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public static String getPlotterType() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 4; i++) {
      char letter = (char)getByteBuffer().get(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1044)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public static void setPlotterType(String val) {
    for (int i = 0; i < 4; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1044)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1044)+i, (byte)' ');
      }
    }
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public static int getGraphicsLu() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1048);
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public static void setGraphicsLu(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1048, val);
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public static String getGraphicsType() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 4; i++) {
      char letter = (char)getByteBuffer().get(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1052)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public static void setGraphicsType(String val) {
    for (int i = 0; i < 4; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1052)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put(((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1052)+i, (byte)' ');
      }
    }
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public static int getLineType() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1056);
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public static void setLineType(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1056, val);
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public static int getAbsUnits() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1060);
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public static void setAbsUnits(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1060, val);
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public static float getXmin() {
    return getByteBuffer().getFloat((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1064);
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public static void setXmin(float val) {
    getByteBuffer().putFloat((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1064, val);
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public static float getXmax() {
    return getByteBuffer().getFloat((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1068);
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public static void setXmax(float val) {
    getByteBuffer().putFloat((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1068, val);
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public static float getYmin() {
    return getByteBuffer().getFloat((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1072);
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public static void setYmin(float val) {
    getByteBuffer().putFloat((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1072, val);
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public static float getYmax() {
    return getByteBuffer().getFloat((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1076);
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public static void setYmax(float val) {
    getByteBuffer().putFloat((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1076, val);
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public static float getXMult() {
    return getByteBuffer().getFloat((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1080);
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public static void setXMult(float val) {
    getByteBuffer().putFloat((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1080, val);
  }

  /** Gets the remote session action flag.
      @return The remote session action flag.
   */
  public static int getRsact() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1084);
  }

  /** Sets the remote session action flag.
      @param val The remote session action flag.
   */
  public static void setRsact(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1084, val);
  }

  /** Gets the default /VISCLASS.
      @return The default /VISCLASS.
   */
  public static int getVisclass() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1088);
  }

  /** Sets the default /VISCLASS.
      @param val The default /VISCLASS.
   */
  public static void setVisclass(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1088, val);
  }

  /** Gets the default /VISDEPTH.
      @return The default /VISDEPTH.
   */
  public static int getVisdepth() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1092);
  }

  /** Sets the default /VISDEPTH.
      @param val The default /VISDEPTH.
   */
  public static void setVisdepth(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1092, val);
  }

  /** Gets the default /VISUALID.
      @return The default /VISUALID.
   */
  public static int getVisid() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1096);
  }

  /** Sets the default /VISUALID.
      @param val The default /VISUALID.
   */
  public static void setVisid(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1096, val);
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public static int getRemote() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1100);
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public static void setRemote(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1100, val);
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public static int getFill() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1104);
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public static void setFill(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1104, val);
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public static int getUseExecutables() {
    return getByteBuffer().getInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1108);
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public static void setUseExecutables(int val) {
    getByteBuffer().putInt((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1108, val);
  }

  /** Gets the Added for DR 10626.
      @return The Added for DR 10626.
   */
  public static float getSockPause() {
    return getByteBuffer().getFloat((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1112);
  }

  /** Sets the Added for DR 10626.
      @param val The Added for DR 10626.
   */
  public static void setSockPause(float val) {
    getByteBuffer().putFloat((L_CMD_CHARS+L_GSW_CHARS)+L_AUXBYTES+(2*(L_MAXAUXINDEX+1))+L_AUXS+(4*L_SECTIONS)+(4*L_USERSCR)+1112, val);
  }

  /** Dumps the data in the buffer to a String. This method is for
      debugging purposes only its syntax may change in the future
      without notice.
      
      @return A string listing the current data in the buffer.
   */
  public static String dumpData() {
    StringBuilder sb = new StringBuilder();
    sb.append("getCommandString     = ").append(getCommandString()    ).append('\n');
    sb.append("getGlobalSwitchString = ").append(getGlobalSwitchString()).append('\n');
    sb.append("getCommandLength     = ").append(getCommandLength()    ).append('\n');
    sb.append("getSwitchLength      = ").append(getSwitchLength()     ).append('\n');
    sb.append("getGlobalSwitchLength = ").append(getGlobalSwitchLength()).append('\n');
    sb.append("getNumberParameters  = ").append(getNumberParameters() ).append('\n');
    sb.append("getCommandName       = ").append(getCommandName()      ).append('\n');
    sb.append("getCommandSupport    = ").append(getCommandSupport()   ).append('\n');
    sb.append("getEngine            = ").append(getEngine()           ).append('\n');
    sb.append("getDsEngine          = ").append(getDsEngine()         ).append('\n');
    sb.append("getDsDefEngine       = ").append(getDsDefEngine()      ).append('\n');
    sb.append("getVerify            = ").append(getVerify()           ).append('\n');
    sb.append("getDebug             = ").append(getDebug()            ).append('\n');
    sb.append("getBreak             = ").append(getBreak()            ).append('\n');
    sb.append("getSysunlock         = ").append(getSysunlock()        ).append('\n');
    sb.append("getBeep              = ").append(getBeep()             ).append('\n');
    sb.append("getStatus            = ").append(getStatus()           ).append('\n');
    sb.append("getCount             = ").append(getCount()            ).append('\n');
    sb.append("getMode              = ").append(getMode()             ).append('\n');
    sb.append("getDatastream        = ").append(getDatastream()       ).append('\n');
    sb.append("getOsType            = ").append(getOsType()           ).append('\n');
    sb.append("getOsName            = ").append(getOsName()           ).append('\n');
    sb.append("getMachine           = ").append(getMachine()          ).append('\n');
    sb.append("getHostname          = ").append(getHostname()         ).append('\n');
    sb.append("getPipeable          = ").append(getPipeable()         ).append('\n');
    sb.append("getLoginPath         = ").append(getLoginPath()        ).append('\n');
    sb.append("getHomePath          = ").append(getHomePath()         ).append('\n');
    sb.append("getPlotNode          = ").append(getPlotNode()         ).append('\n');
    sb.append("getPlotNode2         = ").append(getPlotNode2()        ).append('\n');
    sb.append("getLeft              = ").append(getLeft()             ).append('\n');
    sb.append("getTop               = ").append(getTop()              ).append('\n');
    sb.append("getWidth             = ").append(getWidth()            ).append('\n');
    sb.append("getHeight            = ").append(getHeight()           ).append('\n');
    sb.append("getWindowId          = ").append(getWindowId()         ).append('\n');
    sb.append("getWindowW           = ").append(getWindowW()          ).append('\n');
    sb.append("getWindowH           = ").append(getWindowH()          ).append('\n');
    sb.append("getColormap          = ").append(getColormap()         ).append('\n');
    sb.append("getAuxList           = ").append(getAuxList()          ).append('\n');
    sb.append("getWriteId           = ").append(getWriteId()          ).append('\n');
    sb.append("getReadId            = ").append(getReadId()           ).append('\n');
    sb.append("getUserId            = ").append(getUserId()           ).append('\n');
    sb.append("getWriteAux          = ").append(getWriteAux()         ).append('\n');
    sb.append("getReadAuxs          = ").append(getReadAuxs()         ).append('\n');
    sb.append("getAuxOffset         = ").append(getAuxOffset()        ).append('\n');
    sb.append("getReadAux           = ").append(getReadAux()          ).append('\n');
    sb.append("getMasterslave       = ").append(getMasterslave()      ).append('\n');
    sb.append("getDetached          = ").append(getDetached()         ).append('\n');
    sb.append("getDetachAux         = ").append(getDetachAux()        ).append('\n');
    sb.append("getDetachStart       = ").append(getDetachStart()      ).append('\n');
    sb.append("getNextFileLu        = ").append(getNextFileLu()       ).append('\n');
    sb.append("getPipesize          = ").append(getPipesize()         ).append('\n');
    sb.append("getPropmask          = ").append(getPropmask()         ).append('\n');
    sb.append("getMacro             = ").append(getMacro()            ).append('\n');
    sb.append("getMacroLevel        = ").append(getMacroLevel()       ).append('\n');
    sb.append("getDictionarySize    = ").append(getDictionarySize()   ).append('\n');
    sb.append("getDictionaryCmds    = ").append(getDictionaryCmds()   ).append('\n');
    sb.append("getResultsSize       = ").append(getResultsSize()      ).append('\n');
    sb.append("getResultsBins       = ").append(getResultsBins()      ).append('\n');
    sb.append("getTimer             = ").append(getTimer()            ).append('\n');
    sb.append("getElapse            = ").append(getElapse()           ).append('\n');
    sb.append("getPause             = ").append(getPause()            ).append('\n');
    sb.append("getSeed              = ").append(getSeed()             ).append('\n');
    sb.append("getScratch           = ").append(getScratch()          ).append('\n');
    sb.append("getNformat           = ").append(getNformat()          ).append('\n');
    sb.append("getSecSz             = ").append(getSecSz()            ).append('\n');
    sb.append("getUserscr           = ").append(getUserscr()          ).append('\n');
    sb.append("getTolerance         = ").append(getTolerance()        ).append('\n');
    sb.append("getSyncCount         = ").append(getSyncCount()        ).append('\n');
    sb.append("getPresyncCount      = ").append(getPresyncCount()     ).append('\n');
    sb.append("getInputLu           = ").append(getInputLu()          ).append('\n');
    sb.append("getInputType         = ").append(getInputType()        ).append('\n');
    sb.append("getKeyLu             = ").append(getKeyLu()            ).append('\n');
    sb.append("getKeyType           = ").append(getKeyType()          ).append('\n');
    sb.append("getCrtLu             = ").append(getCrtLu()            ).append('\n');
    sb.append("getCrtType           = ").append(getCrtType()          ).append('\n');
    sb.append("getListLu            = ").append(getListLu()           ).append('\n');
    sb.append("getListType          = ").append(getListType()         ).append('\n');
    sb.append("getLpLu              = ").append(getLpLu()             ).append('\n');
    sb.append("getLpType            = ").append(getLpType()           ).append('\n');
    sb.append("getPlotterLu         = ").append(getPlotterLu()        ).append('\n');
    sb.append("getPlotterType       = ").append(getPlotterType()      ).append('\n');
    sb.append("getGraphicsLu        = ").append(getGraphicsLu()       ).append('\n');
    sb.append("getGraphicsType      = ").append(getGraphicsType()     ).append('\n');
    sb.append("getLineType          = ").append(getLineType()         ).append('\n');
    sb.append("getAbsUnits          = ").append(getAbsUnits()         ).append('\n');
    sb.append("getXmin              = ").append(getXmin()             ).append('\n');
    sb.append("getXmax              = ").append(getXmax()             ).append('\n');
    sb.append("getYmin              = ").append(getYmin()             ).append('\n');
    sb.append("getYmax              = ").append(getYmax()             ).append('\n');
    sb.append("getXMult             = ").append(getXMult()            ).append('\n');
    sb.append("getRsact             = ").append(getRsact()            ).append('\n');
    sb.append("getVisclass          = ").append(getVisclass()         ).append('\n');
    sb.append("getVisdepth          = ").append(getVisdepth()         ).append('\n');
    sb.append("getVisid             = ").append(getVisid()            ).append('\n');
    sb.append("getRemote            = ").append(getRemote()           ).append('\n');
    sb.append("getFill              = ").append(getFill()             ).append('\n');
    sb.append("getUseExecutables    = ").append(getUseExecutables()   ).append('\n');
    sb.append("getSockPause         = ").append(getSockPause()        ).append('\n');
    return sb.toString();
  }
  /** Defines the Colortype structure. */
  public static class Colortype {
    /** The byte buffer. */
    private final ByteBuffer byteBuffer;
    
    /** The offset index. */
    private final int offset;
    
    /** Creates a new instance.
        @param byteBuffer The byte buffer.
        @param offset     The offset index.
     */
    private Colortype(ByteBuffer byteBuffer, int offset) {
      this.byteBuffer = byteBuffer;
      this.offset     = offset;
    }
    /** Gets the byte buffer.
        @return The byte buffer.
     */
    private ByteBuffer getByteBuffer() {
      return byteBuffer;
    }

    /** gets the unknown.
        @return The unknown (an array of size 28).
     */
    public short[] getTable() {
      short[] val = new short[28];
      for (int i = 0; i < val.length; i++) {
        int off = i * 2;
        val[i] = getByteBuffer().getShort(((this.offset + (0)))+off);
      }
      return val;
    }
    /** Gets the unknown at the specified index.
        @return The unknown at the specified index.
     */
    public short getTableAt(int index) {
      int off = index * 2;
      short val = getByteBuffer().getShort(((this.offset + (0)))+off);
      return val;
    }
    /** Sets the unknown.
        @param val The unknown (must be an array of size 28).
     */
    public void setTable(short[] val) {
      if (val.length != 28) {
        throw new IllegalArgumentException("setTable: expected array of"
          + "length 28, given array of length "+val.length+".");
      }
      for (int i = 0; i < val.length; i++) {
        int off = i * 2;
        getByteBuffer().putShort(((this.offset + (0)))+off, val[i]);
      }
    }
    /** Sets the unknown at the specified index.
        @param val The unknown at the specified index.
     */
    public void setTableAt(int index, short val) {
      if (index >= 28) {
        throw new IllegalArgumentException("setTable: index ["+index+"] is out of range ["+28+"]");
      }
      int off = index * 2;
      getByteBuffer().putShort(((this.offset + (0)))+off, val);
    }
  
    /** Summarizes the record.
        @return A string listing the current data in the record.
     */
    public String toString() {
      StringBuilder sb = new StringBuilder();
      sb.append("Colortype: {");
      sb.append(" getTable = ").append(getTable());  
      sb.append(" }");
      return sb.toString();
    }
  }

  //   </editor-fold>
  // </BBMakeGenCode>//GEN-END:BBMakeGenCode
}

