#ifndef XM_MSGMASK_H_
/*
 **************************************************************
                   +------------------------------------+
                   | THIS FILE MUST MATCH msgmask.inc |
                   +------------------------------------+

   Author:  Copy of msgmask.inc / based on XM4.10
   Version: $Id: msgmask.h,v 1.1 2012/05/21 19:54:02 ntn Exp $

   Description: Bit values for the message mask construction

   MIB         03/20/00 Added MSK_NEWFILE MASK DR RRCcl00592
   BWC         06/02/10 Added MSK_NEWLFN MSK DR 785524

 **************************************************************
*/

#define MSK_ZOOM 8
#define MSK_PANX 9
#define MSK_PANY 10
#define MSK_CXMODE 11
#define MSK_EXIT 12
#define MSK_UNZOOM 13
#define MSK_BOXES 14
#define MSK_POINTS 15
#define MSK_MARK 16
#define MSK_ECHO 17
#define MSK_COLOR 18
#define MSK_MODIFY 19
#define MSK_LOOKUP 20
#define MSK_SELECT 21
#define MSK_HLIT 22
#define MSK_NEWFILE 23
#define MSK_NEWLFN 24
#define XM_MSGMASK_H_
#endif /* XM_MSGMASK_H_ */
