package nxm.nmpostlegacy.prim;

import nxm.sys.inc.*;
import nxm.sys.lib.*;
import java.util.*;
import java.text.DecimalFormat;

public class gettime extends Primitive {

  public int open() {
    String  inTime  = MA.getS("INTIME");
    String  result  = MA.getS("RES");
    double sigu    = timeToMidas(inTime);
    DecimalFormat dc = new DecimalFormat();
    dc.applyLocalizedPattern("#########");
    //Double d     = new Double(sigu);
    //M.info("Time = "+sigu);
    //M.info("Time = "+d.toString());
    MR.put("D:"+result,sigu);
    MR.put("A:"+result+"_2",dc.format(sigu));

    return FINISH;
  }

  public static double timeToMidas(String desiredTime) {

    StringTokenizer st = new StringTokenizer(desiredTime, ":");
    String strYear = null;
    String strMonth = null;
    String strDay = null;
    String strHour = null;
    String strMinute = null;
    String strSecond = null;
    try {
      strYear = st.nextToken();
      strMonth = st.nextToken();
      strDay = st.nextToken();
      strHour = st.nextToken();
      strMinute = st.nextToken();
      strSecond = st.nextToken();
    } catch (Exception e) {
      //System.out.println("TimeUtils:timeToMidas - invalid date/time string");
    }

    double theTime;

    if ( (strYear == null) || (strMonth == null) || (strDay == null) ||
        (strHour == null) || (strMinute == null) || (strSecond == null) ) {
      theTime = 0.0;
    } else {

      GregorianCalendar desiredCal = new GregorianCalendar(
          Integer.parseInt(strYear),
          Integer.parseInt(strMonth) - 1,
          Integer.parseInt(strDay),
          Integer.parseInt(strHour),
          Integer.parseInt(strMinute));
      desiredCal.setTimeZone(new SimpleTimeZone(0, "GMT"));
      Date desiredDate = desiredCal.getTime();
      long desiredSeconds = desiredDate.getTime() / 1000;

      GregorianCalendar epochCal = new GregorianCalendar(1950, 0, 1);
      epochCal.setTimeZone(new SimpleTimeZone(0, "GMT"));
      Date epochDate = epochCal.getTime();
      long epochSeconds = epochDate.getTime() / 1000;

      long secondsSinceEpoch = desiredSeconds - epochSeconds;

      theTime = secondsSinceEpoch + Double.parseDouble(strSecond);

      //System.out.println("TimeUtils:timeToMidas - desiredSeconds, epochSeconds, theTime = " + desiredSeconds + ", " + epochSeconds + ", " + theTime);
    }

    return theTime;
  }

  public static double precRound(double val) {
    double round_val;
    long sign = 1;
    if (val < 0)
      sign = -1;

    round_val = ((long) (val*1000 + .5*sign)) / 1000.0;

    return round_val;
  }

}
