/**
  Template Java/C wrapper code for an MPU Library.

  This should be included after defining JMETHOD and CMETHOD, for example:

  #define JMETHOD(M) Java_nxm_dsp_lib_DemodNative_##M
  #define CMETHOD(M) Demod_##M

  Note: the "##" is the token pasting preprocessing operator in the #define above

  @author Jeff Schoen
  @version $Id: MPULibWrappers.h,v 1.5 2011/07/27 18:45:15 ntn Exp $
*/
#include "native.h"

//void* CMETHOD(alloc) ();

JNIEXPORT jlong JNICALL JMETHOD(alloc) (JNIEnv *env, jobject obj) {
  return (jlong)(jpointer) CMETHOD(alloc)();
}

