package nxm.sys.intr;

import nxm.sys.lib.*;

/** Causes the system to beep.

    @author Mike King
    @version $Id: Beep.java,v 1.4 2007/08/30 22:15:41 ntn Exp $
 */
public class Beep extends Intrinsic {

  public int process() {
    String func = MA.getU("FUNC");

    if (func.equals("ON")) {
      M.verify |= Verify.BEEP;
//      MR.put("ENV.VERIFY",Parser.mask2s(Verify.verifyList,M.verify));
    }
    else if (func.equals("OFF")) {
      M.verify &= ~Verify.BEEP;
//      MR.put("ENV.VERIFY",Parser.mask2s(Verify.verifyList,M.verify));
    }
    else {
      int times = MA.getL("FUNC");
      double delay = MA.getD("DELAY");
      for (int i=0; i<times;) {
        Shell.beep();
        if (++i<times) Time.sleep(delay);
      }
    }

    return FINISH;
  }
}
