package nxm.sys.intr;

import nxm.sys.inc.*;
import nxm.sys.lib.*;

/**
  Declare local results parameters.

  By default, all programmer variables are considered 'local' and put 
  into the local results table unless the programmer uses the 'global' 
  keyword.  Thus, no processing is required in this method.

  @author Jeff Schoen
  @version $Id: Local.java,v 1.5 2006/04/24 20:04:45 jph Exp $

*/
public class Local extends Intrinsic {

  public int process() {
    return (FINISH);
  }

}
