package nxm.sys.intr;

import nxm.sys.inc.*;
import nxm.sys.lib.*;

/**
  Resets the NeXtMidas environment.

  @author Jeff Schoen
  @version $Id: Reset.java,v 1.5 2006/09/20 13:08:26 jgs Exp $

*/
public class Reset extends Intrinsic {

  public int process() {

    String func = MA.getU("FUNC");
    if (M.macro != null) {
      M.macro = null;
    }
    if (M.pipeMode != M.POFF) {
      M.pipeMode = M.POFF;
    }

    return (FINISH);
  }
}

