package nxm.sys.intr;

import nxm.sys.inc.*;
import nxm.sys.lib.*;

/** Send messages from the macro language.

    @author  Jeff Schoen / J. Czechowski IV
    @version $Id: Sendto.java,v 1.4 2012/10/02 14:31:29 ntn Exp $
 */
public class Sendto extends Message {

  public int process() {
    Object  from   = (M.macro != null)? M.macro : this;
    boolean sync   = MA.getState("/SYNC",MA.getState("/W"));
    boolean direct = false;
    boolean replace = MA.getState("/REPLACE", false); // since 3.3.0 for BUG 98

    send(sync, direct, replace, from);

    return FINISH;
  }
}
