package nxm.sys.intr;

import nxm.sys.inc.*;
import nxm.sys.lib.*;

/**
  Executes next command in a suspended macro

  @author Jeff Schoen
  @version $Id: Step.java,v 1.3 2006/09/20 13:03:10 jgs Exp $

*/
public class Step extends Intrinsic {

  public int process() {

    if (M.macro == null || M.macro.suspend==0) {
      M.error("No macro suspended ...");
      return (FINISH);
    }
    int step = MA.getL("STEP");
    M.macro.nextIndex += step;
    M.macro.suspend = -1;

    return (FINISH);
  }
}
