#!/usr/bin/python
#
# Defines the pipe handling commands.
#
# @author  J. Czechowski IV
# @since   NeXtMidas 2.1.0
# @version $Id: nmpipes.py,v 1.1 2005/04/28 20:10:53 jxc Exp $

def pipe_on():
  "Starts a piped section."
  global nm
  nm.pipe("ON")

def pipe_init():
  "Starts a piped section."
  global nm
  nm.pipe("INIT")

def pipe_run():
  "Ends a piped section."
  nm.pipe("RUN")

def pipe_pause():
  nm.pipe("PAUSE")

def pipe_wait():
  "Ends a piped section."
  nm.pipe("WAIT")

def pipe_waitfor():
  nm.pipe("WAITFOR")

def pipe_stop():
  nm.pipe("STOP")

def pipe_off():
  nm.pipe("OFF")

