!**************************************************************
!
!  $Id: msgmask.inc,v 1.2 2012/05/21 19:54:02 ntn Exp $
!
!  Description: Bit values for the message mask construction
!
!  MIB         03/20/00 Added MSK_NEWFILE MASK DR RRCcl00592
!  BWC         06/02/10 Added MSK_NEWLFN MSK DR 785524
!
!**************************************************************

	integer*4 MSK_ZOOM
	parameter (MSK_ZOOM = 8)
	integer*4 MSK_PANX
	parameter (MSK_PANX = 9)
	integer*4 MSK_PANY
	parameter (MSK_PANY = 10)
	integer*4 MSK_CXMODE
	parameter (MSK_CXMODE = 11)
	integer*4 MSK_EXIT
	parameter (MSK_EXIT = 12)
	integer*4 MSK_UNZOOM
	parameter (MSK_UNZOOM = 13)
	integer*4 MSK_BOXES
	parameter (MSK_BOXES = 14)
	integer*4 MSK_POINTS
	parameter (MSK_POINTS = 15)
	integer*4 MSK_MARK
	parameter (MSK_MARK = 16)
	integer*4 MSK_ECHO
	parameter (MSK_ECHO = 17)
	integer*4 MSK_COLOR
	parameter (MSK_COLOR = 18)
	integer*4 MSK_MODIFY
	parameter (MSK_MODIFY = 19)
	integer*4 MSK_LOOKUP
	parameter (MSK_LOOKUP = 20)
	integer*4 MSK_SELECT
	parameter (MSK_SELECT = 21)
	integer*4 MSK_HLIT
	parameter (MSK_HLIT = 22)
	integer*4 MSK_NEWFILE
	parameter (MSK_NEWFILE = 23)
	integer*4 MSK_NEWLFN
	parameter (MSK_NEWLFN = 24)
