c************
c  Description:	Defines types of Midas library functions
c
c  Author:	JGS 4/2/90
c  $Revision: 1.9 $
c  $Modtime:   03 Sep 1997 10:34:54  $
c
c************

c X-Midas latest major revision parameter
	real*4 XM_Version
	parameter (XM_Version = 3.70)

c pointer definition
	integer*4 L_M_Ptr, L_M_Ptr_p
	parameter (L_M_Ptr=8)
!if _64BIT
!
!
!
!
!else
	parameter (L_M_Ptr_p=4)
	STRUCTURE /M_PTR/
	  integer*4 p
	  integer*4 FILL
	ENDSTRUCTURE
!endif

!if _SUN|_CNVX|_SOL
!
!endif

c parameters
	integer*4 L_max_ascii, L_max_resname
	parameter (L_max_ascii=80)	! max size of ascii result string
	parameter (L_max_resname=40)	! max size of results name

c auxlib
	integer*4 	M$VALID_AUX
        integer*4       M$GET_AUX_PATH
	integer*4 	M$ADD_READ_AUX
	integer*4 	M$DEL_READ_AUX
        integer*4       M$DEFINE_AUX
c commolink
	integer*4	M$DELETE, M$RENAME
	integer*4	M$IMPORT, M$EXPORT
	integer*4	M$GET_INPUT, M$FORM_PATH, M$GET_DEFAULT
	integer*4	M$MORE, M$LDIRECTORY, M$LOCK
	integer*4	M$FILE, M$FILENAME, M$FILENAMEOPT, M$REMOTE_NAME
	integer*4	M$GETLOG
c controls
	integer*4	M$MWINIT, M$LWINIT, M$FWINIT, M$DWINIT, M$WGETID
	integer*4	M$MWGET, M$LWGET, M$FWGET, M$DWGET, M$WOFFSET
	logical*4	M$DO
c blockio
c+++
c DR 5255
!if _UNIX
	integer*4	M$DISKUNX_DEV
!endif
c---
c easyio
	integer*4	M$GET_QUALIFIER, M$GET_UQUALIFIER
	integer*4	M$XFER_LENGTH
	integer*4	M$NEXT_FILE_LU
c keywords
	integer*4	M$GET_KEYWORD,M$GET_KEYWORD_TAG,M$GET_KEYEXTNEXT
	integer*4	M$PUT_KEYWORD,M$PUT_KEYWORD_TAG
	integer*4	M$DEL_KEYWORD,M$DEL_KEYWORD_TAG
	integer*4	M$REPL_KEYWORD,M$REPL_KEYWORD_TAG
	integer*4	M$FIND_KEYMAIN,M$FIND_KEYEXT
	integer*4	M$FIND_TAGEXT,M$FIND_TIMESEXT
	integer*4	M$PUT_EXT,M$GET_EXT,M$GET_KEYEXTN
	integer*4	M$FIND_KEYDATA
	integer*4	M$PUT_KEYDATA, M$DEL_KEYDATA, M$GET_KEYDATA
	integer*4	M$SCOPE_KEYWORD, M$SCOPE_KEYWORD_QUIET
c macros
	integer*4	M$LOAD_MCR, M$DSENGINEID
	logical*4	M$GOTO
c math
	integer*4	M$FFTSIZE,M$FFTFLAGS
	integer*4	M$WINDOW,M$WINDOW_ID,M$GENRADIX,M$RECAST,M$CALC
	logical*4	M$DEQ, M$DEQT
c messages
	integer*4	M$BROADCAST_BITS, M$NEXT_MSG, M$GET_MSG, M$GET_MSGL
c+++
c DR 5366
c Old
c	integer*4	M$GET_MESSAGE, M$GETW_MESSAGE, M$MSGFUNC
c New
	integer*4	M$GET_MESSAGE, M$GETW_MESSAGE
!if _PFC
!
!else
	integer*8	M$MSGFUNC
!endif
c---
c pipeio
	integer*4	M$PHEADLOC
c picks
	character*1	M$_PICK
	character*(L_max_ascii)	M$UPICK
	character*(L_max_ascii)	M$APICK
	complex*16	M$CPICK
	real*8		M$DPICK
	real*4		M$FPICK
	integer*4	M$LPICK
	integer*2	M$IPICK
	byte		M$BPICK
	integer*4	M$PICK, M$QPICK, M$TPICK, M$APICK_POST, M$UAPICK
	logical*4	M$SPICK, M$PPICK
c switches
	integer*4	M$GET_SWITCH, M$GET_SWITCH_DEF
	integer*4	M$GET_USWITCH, M$FIND_SWITCH
	logical*4	M$GET_PSWITCH, M$GET_SSWITCH, M$GET_SSWITCH_DEF
	real*8		M$GET_DSWITCH, M$GET_DSWITCH_DEF
c results
	character*1	M$RFIND, M$RDISP
	logical*4	M$RGOOD
	integer*4	M$GET_RESULT, M$PUT_RESULT, M$DEL_RESULT
	integer*4	M$STR2RESULT, M$RFILTER, M$RATTRIBUTES
	integer*4	M$RGET, M$RPUT, M$RDEL, M$RNEXT
	integer*4	M$RESGET, M$VRESGET, M$RESPUT, M$VRESPUT
	integer*4	M$VRESHCB, M$RMARK_MLEVEL
	integer*4	M$RMARK_SMLEVEL, M$RMARKED_MLEVEL
	integer*4	M$RATTR_STR2MASK, M$RATTR_MASK2STR
c shell
	logical*4	M$FIND_COMMAND
c type4000
	integer*4	M$VRBINIT, M$VRBFIND, M$VRBGET, M$VRBPUT
	integer*4	M$VRBCLR, M$VRBFREE
c type5000
	integer*4	M$SUB_FIND,M$SUB_OFFSET
        character*24    M$SUB_NAME
        character*2     M$SUB_FORMAT
c utilities
	integer*4	M$SEARCH, M$SEARCHB, M$LENGTH, M$LENGTHQ, M$LENGTHD
	integer*4	M$NEXTLINE, M$NEXTLINE_SOURCE
	integer*4	M$PARSE, M$CLEAN, INDEXB
	integer*4	M$POWER2GE, M$POWER2LE
	integer*4	M$A2D, M$A2DV, M$D2A, M$L2A, M$A2DI, M$F2A
	integer*4	M$L2A_FORM, M$D2A_FORM
	integer*4	M$DEG2DM, M$DEG2DMS, M$DMS2DEG, M$SEC2TOD, M$TOD2SEC
	integer*4	M$TIMES2TOD, M$TOD2TIMES, M$SEC2TSPEC
	integer*4	M$BPA, M$BPE, M$BPS, M$SPA, M$NPT, M$NPM
	integer*4	M$TYPE, M$CHK, M$LOGICAL, M$ENV
	logical*4	M$LOGICAL_TEST
	character*35	M$UNITS_NAME
	character*30	M$FORMAT_NAME
	character*9	M$COMPTYPE_NAME
	character*2	M$TEST_FORMAT
	character*2	M$PROMOTE_FORMAT
	character*1	M$PROMOTE_TYPE
	real*8		M$CALCULATOR
	integer*4	M$TIME_FORMAT, M$TIMES2STR
c vector
	character*1	M$VPROMOTE
c array op
	integer*4	M$AOP, M$AOPF, M$AOP_FIND, M$AOP_ADDR
c dictionary
	integer*4	M$DICTIONARY_FETCH, M$DICTIONARY_LOOKUP
	integer*4	M$DICTIONARY_APPEND
	integer*4	M$FILTERED_FETCH
c macros
	integer*4	M$LOAD_MACRO
	integer*4	M$EXECUTE_JUMP
	integer*4	M$POP_MACRO_STACK, M$PUSH_MACRO_STACK
	integer*4	M$MCR_FETCH
	logical*4	M$MCR_FETCH_NEXT
	integer*4	M$READ_OFFSET
c semlib
	integer*4	M$CREATE_SEMAPHORE
	integer*4	M$DELETE_SEMAPHORE
	integer*4	M$LOCK_SEMAPHORE
	integer*4	M$UNLOCK_SEMAPHORE
c shmlib
	integer*4	M$MAP_SHM
c sedit
	integer*4	M$SUBS
	integer*4	M$SUBSL
	integer*4	M$GSUB
	integer*4	M$GSUBL
	integer*4	M$STRIM

        !!! Should use the X-Midas version of this function
        !! talk with Rich Holley!!!
        real*4          SECNDS
        external        SECNDS

!if _PGF77
!
!if _64BIT
!
!else
!
!endif
!endif
